/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.VersionSystemDao;
import com.portofolio.dto.VersionDto;
import com.portofolio.entity.VersionSystem;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;

@Lazy
@Service
public class VersionSystemService extends BaseServiceImpl {

	@Lazy
	@Autowired
	VersionSystemDao versionSystemDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;

	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(VersionDto versionDto) {
		result.clear();
		Integer kdVersion = getIdTerahirNoNegara(VersionSystem.class, "kdVersion");
		VersionSystem versionSystem = CommonUtil.findOne(versionSystemDao, kdVersion);
		if (CommonUtil.isNullOrEmpty(versionSystem)) {
			versionSystem = new VersionSystem();
			versionSystem.setNoRec(generateUuid32());
			versionSystem.setVersion(1);
			versionSystem.setKdVersion(kdVersion);
			BeanUtils.copyProperties(versionDto, versionSystem);
			versionSystem = versionSystemDao.save(versionSystem);
			result.put("versionSystem", versionSystem);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("desaKelurahan.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(VersionDto versionDto, Integer kdVersion, Integer version) {
		result.clear();
		VersionSystem versionSystem = CommonUtil.findOne(versionSystemDao, kdVersion);
		if (CommonUtil.isNotNullOrEmpty(versionSystem)) {
			if (version < versionSystem.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(versionDto, versionSystem);
			versionSystem = versionSystemDao.save(versionSystem);
			result.put("versionSystem", versionSystem);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	@Transactional
	public Map<String, Object> delete(Integer kdVersion, Integer version) {
		result.clear();
		VersionSystem versionSystem = CommonUtil.findOne(versionSystemDao, kdVersion);
		if (CommonUtil.isNotNullOrEmpty(versionSystem)) {
			if (version < versionSystem.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			versionSystem.setStatusEnabled(false);
			versionSystem = versionSystemDao.save(versionSystem);
			result.put("versionSystem", versionSystem);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	public Map<String, Object> grid(String sort, String dir, String namaVersionSystem) {
		result.clear();
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<VersionSystem> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaVersionSystem)) {
			list = versionSystemDao.findAllList(pageReq);
			result = createTree(list);
		} else {
			list = versionSystemDao.findAllList(namaVersionSystem, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}
	
	
	public Map<String, Object> combo(String sort, String dir, String namaVersionSystem) {
		result.clear();
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<VersionSystem> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaVersionSystem)) {
			list = versionSystemDao.findAllListCombo(pageReq);
			result = createTree(list);
		} else {
			list = versionSystemDao.findAllListCombo(namaVersionSystem, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}

	private Map<String, Object> createTree(List<VersionSystem> nodes) {

		Map<String, VersionSystem> mapTmp = new HashMap<>();

		// Save all nodes to a map
		for (VersionSystem current : nodes) {
			mapTmp.put(current.getKdVersion().toString(), current);
		}

		// loop and assign parent/child relationships
		for (VersionSystem current : nodes) {
			Integer parentId = current.getKdVersionHead();

			if (parentId != null) {
				VersionSystem parent = mapTmp.get(parentId.toString());
				if (parent != null) {
					// current.setVersionHead(parent);
					parent.addChild(current);
					mapTmp.put(parentId.toString(), parent);
					mapTmp.put(current.getKdVersion().toString(), current);
				}
			}
		}

		List<VersionSystem> versionSystems = new ArrayList<>();
		for (VersionSystem d : mapTmp.values()) {
			if (CommonUtil.isNullOrEmpty(d.getKdVersionHead()) || CommonUtil.isNotNullOrEmpty(d.getChildren())) {
				versionSystems.add(d);
			}

		}
		Map<String, Object> da = new HashMap<>();
		da.put("versionSystems", versionSystems);
		return da;
	}

	public Map<String, Object> findByKdVersionSystem(Integer kdVersion, boolean isHierarki) {
		result.clear();
		List<VersionSystem> list = new ArrayList<>();
		if (isHierarki) {
			list = versionSystemDao.findByKdVersionSystemWithIsHierarkiTrue(kdVersion);
			result = createTree(list);
		} else {
			list = versionSystemDao.findByKdVersionSystemWithIsHierarkiFalse(kdVersion);
			result.put("versionSystems", list);
		}
		resultSuccessful();
		return result;

	}

	public List<Map<String, Object>> treeVersionSystem(Integer kdVersion) {
		List<Map<String, Object>> listObjectModulAplikasiByHead = versionSystemDao.findVersionSystemByHead(kdVersion);
		List<Map<String, Object>> tmpListObjectModulAplikasiByHead = new ArrayList<Map<String, Object>>();
		for (Map<String, Object> object : listObjectModulAplikasiByHead) {
			tmpListObjectModulAplikasiByHead.add(object);
		}
		return listObjectModulAplikasiByHead;

	}

}